/* DEMO2.C : PISO-725 D/I/O demo				  */
/* step 1  : run DEMO2.EXE					  */
/* -------------------------------------------------------------- */
#include "PIO.H"

void piso_725_do(char DoValue);
char piso_725_do_readback(void);
char piso_725_di(void);

WORD wBase,wIrq;

int main()
{
int  i,j,k,k1,k2,l1,l2,jj,dd,j1,i1,j2,i2;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
long lOutPad1,lOutPad2,lInPad1,lInPad2;
char c,DI,DO,ReadBack;

clrscr();
/* step 1: find address-mapping of PIO/PISO cards		  */
wRetVal=PIO_DriverInit(&wBoards,0x80,0x0C,0x00);  /* for PISO-725 */
printf("\nThrer are %d PISO-725 Cards in this PC",wBoards);
if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

/* step 2: enable all D/I/O port				  */
outportb(wBase,1);				  /* enable D/I/O */

printf("\n\n");
DO=1;
for(;;)
   {
   gotoxy(1,6);
   piso_725_do(DO);
   printf("\nOutput   DO[0..7] = [%2x]",DO&0xff);

   delay(12000);
   gotoxy(1,7);
   ReadBack=piso_725_do_readback();
   printf("\nReadBack DO[0..7] = [%2x]",ReadBack&0xff);

   gotoxy(1,9);
   DI=piso_725_di();
   printf("\nInput    DI[0..7] = [%2x]",DI&0xff);

   delay(12000);
   DO=DO<<1; if (DO==0) DO=1;
   if (kbhit()!=0) break;
   }
PIO_DriverClose();
}

/* -------------------------------------------------------------- */

void piso_725_do(char DoValue)
{
outportb(wBase+0xc0,DoValue);
}

/* -------------------------------------------------------------- */

char piso_725_do_readback(void)
{
return(inportb(wBase+0xc0) ^ 0xff);
}

/* -------------------------------------------------------------- */

char piso_725_di(void)
{
return(inportb(wBase+0xc4));
}

