/* DEMO4.C : PISO-725 Interrupt (DI0 initial low)		  */
/* step 1  : DI0 to function generator				  */
/* step 2  : run DEMO4.EXE					  */
/* -------------------------------------------------------------- */
#include "PIO.H"

#define A1_8259 0x20
#define A2_8259 0xA0
#define EOI	0x20

WORD init_low();
void interrupt (*oldfunc) ();
static void interrupt irq_service();
int COUNT_L,COUNT_H,irqmask,now_int_state;

WORD wBase,wIrq;

int main()
{
int  i,j,k,k1,k2,l1,l2,jj,dd,j1,i1,j2,i2;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;

clrscr();
/* step 1: find address-mapping of PIO/PISO cards		  */
wRetVal=PIO_DriverInit(&wBoards,0x80,0x0C,0x00);  /* for PISO-725 */
printf("\nThrer are %d PISO-725 Cards in this PC",wBoards);
if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

/* step 2: enable all D/I/O port				  */
outportb(wBase,1);				  /* enable D/I/O */

init_low();

printf("\n\n***** show the count of High_pulse *****\n");
for(;;)
   {
   gotoxy(1,8);
   printf("\nCOUNT_H=[%5d]",COUNT_H);
   if (kbhit()!=0) break;
   }

disable();

outportb(wBase+5,0);			 /* disable all interrupt */
if (wIrq<8)
   {
   setvect(wIrq+8,oldfunc);
   }
else
   {
   setvect(wIrq-8+0x70,oldfunc);
   }
PIO_DriverClose();
}

/* -------------------------------------------------------------- */
WORD init_low()
{
DWORD dwVal;

disable();
outportb(wBase+5,0);			 /* disable all interrupt */

if (wIrq<8)
   {
   oldfunc=getvect(wIrq+8);
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   setvect(wIrq+8, irq_service);
   }
else
   {
   oldfunc=getvect(wIrq-8+0x70);
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & 0xfb);			  /* IRQ2 */
   irqmask=inportb(A2_8259+1);
   outportb(A2_8259+1,irqmask & (0xff ^ (1 << (wIrq-8))));
   setvect(wIrq-8+0x70, irq_service);
   }

outportb(wBase+0x2a,1); 	       /* non-invert DI0	  */

now_int_state=0x0;		       /* now DI0 is low	  */
outportb(wBase+5,0x1);		       /* enable DI0 interrupt	  */
enable();
}

/* -------------------------------------------------------------- */
void interrupt irq_service()
{
if (now_int_state==1)		 /* now DI0 change to low	  */
   {				 /* INT_CHAN_0 = !DI0		  */
   COUNT_L++;			 /* find a low pulse (DI0)	  */
   if ((inportb(wBase+7)&1)==0)  /* DI0 still fixed in low	  */
      { 			 /* need to generate a high pulse */
      outportb(wBase+0x2a,1);	 /* INV0 select noninverted input */
      now_int_state=0;		 /* now DI0=low 		  */
      }
   else now_int_state=1;	 /* now DI0=High		  */
   }
else				 /* now DI0 change to high	  */
   {				 /* INT_CHAN_0 = DI0		  */
   COUNT_H++;			 /* find a high pulse (DI0)	  */
   if ((inportb(wBase+7)&1)==1)  /* DI0 still fixed in high	  */
      { 			 /* need to generate a high pulse */
      outportb(wBase+0x2a,0);	 /* INV0 select inverted input	  */
      now_int_state=1;		 /* now DI0=high		  */
      }
   else now_int_state=0;	 /* now DI0=low 		  */
   }

if (wIrq>=8) outportb(A2_8259,0x20);
outportb(A1_8259,0x20);
}
