/* DEMO6.C : PISO-725 Interrupt (Multi interrupt source)	  */
/*	      DI0/2/4/5: initial low ,	DI1/3/6/7 : initial high  */
/* step 1  : connect DI0/1/2/3/4/5/6/7	to external signals	  */
/* step 2  : run DEMO6.EXE					  */
/* -------------------------------------------------------------- */
#include "PIO.H"

#define A1_8259 0x20
#define A2_8259 0xA0
#define EOI	0x20

WORD init();
void interrupt (*oldfunc) ();
static void interrupt irq_service();
int  irqmask,now_int_state,new_int_state,invert,int_c,int_num;
int  CNT_L1,CNT_H1,CNT_L2,CNT_H2;
int  CNT_L3,CNT_H3,CNT_L4,CNT_H4;
int  CNT_L5,CNT_H5,CNT_L6,CNT_H6;
int  CNT_L7,CNT_H7,CNT_L8,CNT_H8;

WORD wBase,wIrq;

int main()
{
int  i,j,k;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;

clrscr();
/* step 1: find address-mapping of PIO/PISO cards		  */
wRetVal=PIO_DriverInit(&wBoards,0x80,0x0C,0x00);  /* for PISO-725 */
printf("\nThrer are %d PISO-725 Cards in this PC",wBoards);
if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

/* step 2: enable all D/I/O port				  */
outportb(wBase,1);				  /* enable D/I/O */

CNT_L1=CNT_L2=CNT_L3=CNT_L4=CNT_L5=CNT_L6=CNT_L7=CNT_L8=0;
CNT_H1=CNT_H2=CNT_H3=CNT_H4=CNT_H5=CNT_H6=CNT_H7=CNT_H8=0;
init();

printf("\n\n***** show the count of High_pulse & Low_pulse *****\n");
for(;;)
   {
   gotoxy(1,8);
   printf("\nCNT_L1/2/3/4/5/6/7/8=[%5d,%5d,%5d,%5d,%5d,%5d,%5d,%5d]",
	 CNT_L1,CNT_L2,CNT_L3,CNT_L4,CNT_L5,CNT_L6,CNT_L7,CNT_L8);
   printf("\nCNT_H1/2/3/4/5/6/7/8=[%5d,%5d,%5d,%5d,%5d,%5d,%5d,%5d]",
	 CNT_H1,CNT_H2,CNT_H3,CNT_H4,CNT_H5,CNT_H6,CNT_H7,CNT_H8);
   if (kbhit()!=0) break;
   }

disable();

outportb(wBase+5,0);			 /* disable all interrupt */
if (wIrq<8)
   {
   setvect(wIrq+8,oldfunc);
   }
else
   {
   setvect(wIrq-8+0x70,oldfunc);
   }
PIO_DriverClose();
}

/* -------------------------------------------------------------- */

WORD init()
{
DWORD dwVal;

disable();
outportb(wBase+5,0);			 /* disable all interrupt */

if (wIrq<8)
   {
   oldfunc=getvect(wIrq+8);
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   setvect(wIrq+8, irq_service);
   }
else
   {
   oldfunc=getvect(wIrq-8+0x70);
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & 0xfb);			  /* IRQ2 */
   irqmask=inportb(A2_8259+1);
   outportb(A2_8259+1,irqmask & (0xff ^ (1 << (wIrq-8))));
   setvect(wIrq-8+0x70, irq_service);
   }

invert=0x35;
outportb(wBase+0x2a,invert);	       /* non-invert  DI0/2/4/5   */
				       /*     invert  DI1/3/6/7   */
				       /*      00110101 	  */
now_int_state=0xCA;		       /* now  DI0/2/4/5 = low	  */
				       /* now  DI1/3/6/7 = high   */
				       /*      11001010 	  */
outportb(wBase+5,0xFF); 	       /* enable all interrupt	  */
enable();
}

/* -------------------------------------------------------------- */

void interrupt irq_service()
{
int_num++;

new_int_state=inportb(wBase+7)&0xFF;
int_c=new_int_state^now_int_state;

if ((int_c&0x1)!=0)		 /* now INT_CHAN_0 change to high */
   {
   if ((new_int_state&0x01)!=0)
      {
      CNT_H1++;
      }
   else 			 /* now INT_CHAN_0 change to low  */
      {
      CNT_L1++;
      }
   invert=invert^1;		 /* generate a high pulse	  */
   }

if ((int_c&0x2)!=0)		 /* now INT_CHAN_1 change to high */
   {
   if ((new_int_state&0x02)!=0)
      {
      CNT_H2++;
      }
   else 			 /* now INT_CHAN_1 change to low  */
      {
      CNT_L2++;
      }
   invert=invert^2;		 /* generate a high pulse	  */
   }

if ((int_c&0x4)!=0)		 /* now INT_CHAN_2 change to high */
   {
   if ((new_int_state&0x04)!=0)
      {
      CNT_H3++;
      }
   else 			 /* now INT_CHAN_2 change to low  */
      {
      CNT_L3++;
      }
   invert=invert^4;		 /* generate a high pulse	  */
   }

if ((int_c&0x8)!=0)		 /* now INT_CHAN_3 change to high */
   {
   if ((new_int_state&0x08)!=0)
      {
      CNT_H4++;
      }
   else 			 /* now INT_CHAN_3 change to low  */
      {
      CNT_L4++;
      }
   invert=invert^8;		 /* generate a high pulse	  */
   }

if ((int_c&0x10)!=0)		 /* now INT_CHAN_4 change to high */
   {
   if ((new_int_state&0x10)!=0)
      {
      CNT_H5++;
      }
   else 			 /* now INT_CHAN_4 change to low  */
      {
      CNT_L5++;
      }
   invert=invert^0x10;		 /* generate a high pulse	  */
   }

if ((int_c&0x20)!=0)		 /* now INT_CHAN_5 change to high */
   {
   if ((new_int_state&0x20)!=0)
      {
      CNT_H6++;
      }
   else 			 /* now INT_CHAN_5 change to low  */
      {
      CNT_L6++;
      }
   invert=invert^0x20;		 /* generate a high pulse	  */
   }

if ((int_c&0x40)!=0)		 /* now INT_CHAN_6 change to high */
   {
   if ((new_int_state&0x40)!=0)
      {
      CNT_H7++;
      }
   else 			 /* now INT_CHAN_6 change to low  */
      {
      CNT_L7++;
      }
   invert=invert^0x40;		 /* generate a high pulse	  */
   }

if ((int_c&0x80)!=0)		 /* now INT_CHAN_7 change to high */
   {
   if ((new_int_state&0x80)!=0)
      {
      CNT_H8++;
      }
   else 			 /* now INT_CHAN_7 change to low  */
      {
      CNT_L8++;
      }
   invert=invert^0x80;		 /* generate a high pulse	  */
   }

now_int_state=new_int_state;
outportb(wBase+0x2a,invert);

if (wIrq>=8) outportb(A2_8259,0x20);
outportb(A1_8259,0x20);
}

